armsoc(__drivermansuffix__)

NAME
armsoc - Arm SoC graphics

SYNOPSIS
Section "Device"
  Identifier "devname"
  Driver "armsoc"
  ...
EndSection

DESCRIPTION
armsoc is an __xservername__ driver for Arm Mali SoCs.

SUPPORTED HARDWARE
armsoc supports the Mali-T400 & Mali-T60x

CONFIGURATION DETAILS
Please refer to __xconfigfile__(__filemansuffix__) for general configuration details. This section only covers configuration details specific to this driver.

The following driver Options are supported

Option "Debug" "boolean"
    Enable debug logging.

    Default: Debug logging is Disabled

Option "NoFlip" "boolean"
    Disable buffer flipping.

    Default: Flipping is Enabled

Option "DriverName" "string"
    The name of the drm driver to use.

    Default: NULL

Option "BusID" "string"
    The Bus ID of the drm device to use.

    Default: NULL

Option "DRICard" "integer"
    Select which dri card to use.

    Default: 0

Option "InitFromFBDev" "string"
    Specifies an fbdev device node (such as "/dev/fb0") to use to initialize the DRM scanout buffer. Specifying this option only makes sense (and is required) when X is started with the parameter "-background none". The InitFromFBDev functionality is limited to when the fbdev device pixel format matches the format of the X screen. This includes bits-per-pixel and RGB ordering and size. If the driver is unable to copy from the fbdev device then an error will be logged, and the -background none functionality will be disabled.

    Default: NULL

Option "UMP_LOCK" "boolean"
    Use the umplock module for cross-process access synchronization. It should be only enabled for Mali400

    Default: Umplock is Disabled

DRM DEVICE SELECTION
Either the DRM driver name or bus ID can be specified using e.g.
Section "Device"
  Driver "armsoc"
  Option "DriverName" "pl111_drm"
EndSection
or
Section "Device"
  Driver "armsoc"
  Option "BusID"      "platform:pl111_drm:00"
EndSection
If neither of these are set then /dev/dri/card0 is used. In this case
the card number can be set using the "DRICard" option.
Section "Device"
  Driver "armsoc"
  Option "DRICard"      "1"
EndSection

OUTPUT CONFIGURATION
The driver supports runtime configuration of detected outputs. You can use the xrandr tool to control outputs on the command line as follows:
    xrandr --output output --set property value
Note that you may need to quote property and value arguments that contain spaces. Each output listed below may have one or more properties associated with it (like a binary EDID block if one is found). Some outputs have unique properties which are described below. See the "MULTIHEAD CONFIGURATIONS" section below for additional information. TODO

See __xconfigfile__(__filemansuffix__) for information on associating Monitor sections with these outputs for configuration. Associating Monitor sections with each output can be helpful if you need to ignore a specific output, for example, or statically configure an extended desktop monitor layout.

MULTIHEAD CONFIGURATIONS
The number of independent outputs is dictated by the number of CRTCs (in X parlance) a given chip supports. The actual number of displays supported will depend on the board. But a built-in LCD and external HDMI are a common configuration. You can use the "xrandr" tool, or various desktop utilities, to change your output configuration at runtime. To statically configure your outputs, you can use the "Monitor-<type>" options along with additional monitor sections in your xorg.conf to create your screen topology. The example below puts the VGA output to the right of the builtin laptop screen, both running at 1024x768.
Section "Monitor"
  Identifier "Laptop FooBar Internal Display"
  Option "Position" "0 0"
EndSection
Section "Monitor"
  Identifier "Some Random CRT"
  Option "Position" "1024 0"
  Option "RightOf" "Laptop FoodBar Internal Display"
EndSection
Section "Device"
  Driver "armsoc"
  Option "monitor-LVDS" "Laptop FooBar Internal Display"
  Option "monitor-VGA" "Some Random CRT"
EndSection

SEE ALSO
__xservername__(__appmansuffix__), __xconfigfile__(__filemansuffix__), Xserver(__appmansuffix__), X(__miscmansuffix__)

AUTHORS
Authors include: Ian Elliott, Rob Clark.